//maybe should be changed
import { getTranslation } from "../labels";
import { executeAction, sendRefreshRequest, sendSearchRequest, setCurrentObjectPath } from "../redux/actions";
import * as Util from "./util";
import { getNotificationMethod } from "../initializer";

export const onFileShortcut = (physicalKey, viewStatus) => {
  const showNotification = getNotificationMethod();
  setTimeout (()=> {const fileInputElements = document.querySelectorAll('input[type=file]');
  console.log("filinput", fileInputElements)
  console.log("filinput active", document.activeElement)
  //uploading only should works for CEV
  if (viewStatus && viewStatus.tdl.type === "CEV") {
    const indx = parseInt(physicalKey) - 1
    if (indx < fileInputElements.length) fileInputElements[indx].click();
  }
},500)
}

export const onActionShortcut = (physicalKey, viewStatus, dispatch) => {
  const usecaseId = viewStatus.usecaseId;
  const indx = parseInt(physicalKey) - 1
  const acts = viewStatus.getAvailableHeaderActions()[0];
  if (indx < acts.length) {
    const action = viewStatus.getAvailableHeaderActions()[0][indx];
    if (!action) { return false; }
    if (!Util.isAvailableAction(action)) {
       showNotification({
        message: getTranslation("actionNotAvailable"),
        type: "error",
      }); 
      return false;
    }
    if (viewStatus) {
      dispatch(setCurrentObjectPath(usecaseId, ""));
      dispatch(sendRefreshRequest(usecaseId, true, (response) => {
        if (response.data.output.errorMessages.length == 0) {
          dispatch(executeAction(usecaseId, action.tdlId, action.responseType, () => {
          }));
        } else console.log("there is an error")
      }));
    }
  }
}

export const onSearchShortcut = (viewStatus, dispatch) => {
  //search only for SMS pages
  if (viewStatus && viewStatus.tdl.type === "SMS") {
    dispatch(sendSearchRequest(viewStatus.usecaseId));
  }
}
